<template>
  <div id="products">
    <div class="products-cover">
      <div class="pr-capture">
        <h5>Женственность с Комфортом!</h5>
        <p>Новый взгляд на вещи - Smart Casual! <br> Примерь свою свободу.</p>
      </div>
    </div>
    <div class="categories-panel">
      <div class="container categories-wrapper">
        <div class="form-group m-dropdown" v-click-outside="hideCategories">
          
          <label class="filter-label" @click="showCategories = !showCategories;"><span>КАТЕГОРИИ</span> <span class="fa fa-angle-down"></span></label>

          <ul v-if="showCategories" class="m-dropdown-menu" >
            <li v-for="c in categories" @click.stop="setCategory(c)">{{c}} <span v-if="filters.category.includes(c)" class="checked pull-right"></span></li>
          </ul>
        </div>

        <div class="form-group m-dropdown" v-click-outside="hideSort">
          
          <label class="filter-label" @click="showSort = !showSort;"><span>ПО</span> <span class="fa fa-angle-down"></span></label>

          <ul v-if="showSort" class="m-dropdown-menu" >
            <li v-for="c in sorts" @click.stop="setSort(c)">{{c}} <span v-if="filters.sort === c" class="checked pull-right"></span></li>
          </ul>
        </div>

        <span class="mr-4" v-if="categoriesChanged()" ><span class="clear-all" @click="clearAll">ОЧИСТИТЬ</span></span>
      </div>
    </div>
    <div class="container products-block">
      <div>
        <card-loader :loopCount="8" v-if="loading"/>
        <products-list :products_list="products" :filters="filters" />
      </div>
    </div>
  </div>
</template>


<script>
import ProductsList from "@/components/products/ProductsList";
import CardLoader from "@/components/shared/CardLoader";
import axios from "axios";
import _ from "lodash";

export default {
  name: "allProducts",
  components: { ProductsList, CardLoader},
  data() {
    return {
      categories: undefined,
      products: undefined,
      loading: false,
      showCategories: false, showSort: false,
      filters: {
        category: [],
        sort: ''
      },
      categories: ['Dresses', 'Accessories', 'Swimsuits'],
      sorts: ['Цена по убыванию', 'Цена по возрастанию', 'Сначала Новое', 'Сначала Старое']
    };
  },
  methods: {
    getAllProducts: function() {
      this.loading = true;
      this.$http
        .get(`${process.env.VUE_APP_BASE_URL}/products`)
        .then(response => {
          this.loading = false;
          this.products = response.data;
          this.categories = response.data.map(pr => pr.productCategory).filter((c, ind, arr) => arr.indexOf(c) === ind);
        })
        .catch(error => {
          console.log(error);
        });
    },
    setCategory(c) {
      if (this.filters.category.includes(c)) {
        this.filters.category.some((c1, ind, arr) => {
          if (c1 === c) {
            arr.splice(ind, 1);
          }
        });
      } else {
        this.filters.category.push(c);
      }
    },
    hideCategories() {
      this.showCategories = false;
    },
    setSort(c) {
      this.filters.sort = c;
      this.showSort = false;
    },
    hideSort() {
      this.showSort = false;
    },
    categoriesChanged() {
      return this.filters.category.length >= 1 || this.filters.sort;
    },
    clearAll() {
      this.filters.category = [];
      this.filters.sort = '';
    }
  },

  created() {
    this.getAllProducts();
  }
};
</script>

<style lang="scss">
#products {
  background-color: #f9f9f9;
  .products-cover {
    height: 500px;
    background-image: url("../assets/main-cover-1.png");
    background-position: right 10%;
    background-color: #f7ecda;
    background-size: 70%;
    background-repeat: no-repeat;
    position: relative;
    z-index: 1000;
    .pr-capture {
      position: absolute;
      top: 40%;
      left: 2%;
      background: rgba(255, 255, 255, 0.8);
      display: inline-block;
      padding: 20px;
      margin: 0;
      max-width: 450px;
      h5 {
        font-size: 22px;
      }
      p {
        font-size: 12px;
        color: gray;
      }
    }
  }
  @media (max-width: 768px) {
    .products-cover {
      display: none;
    }
  }
  .products-block {
    margin-top: 40px;
  }

  .categories-panel {
    margin: 20px 0;
    height: 80px;
    background-color: #faf8f5;
    border: 1px solid $maincolor;
    .categories-wrapper {
      display: flex;
      line-height: 80px;
      & > div {
        margin-right: 10px;
      }
    }
    ul {
      line-height: normal;
      min-width: 240px;
      font-size: 16px;
      text-transform: uppercase;
      color: gray;
      box-shadow: 0 5px 10px 0 rgba(0,0,0,.2);
    }
    .filter-label {
      display: flex;
      justify-content: space-between;
      margin-bottom: 0;

      .fa {
        margin-left: 10px;
        line-height: 80px;
      }
    }

    .clear-all {
      font-weight: bold;
      text-decoration: underline;
      margin-left: 20px;
      cursor: pointer;

      &:hover {
        color: gray;
      }
    }
  }

  input {
    background-color: #faf8f5;
  }
}
@media (max-width: 768px){
  #products {
    padding-top: 20px;
  }
}
</style>
